/* ***************************************************************************
 * linux_x11events.c -- event loop support for linux xwindow.
 *
 * Copyright (C) 2016-2018 by Liu Chao <lc-soft@live.cn>
 *
 * This file is part of the LCUI project, and may only be used, modified, and
 * distributed under the terms of the GPLv2.
 *
 * (GPLv2 is abbreviation of GNU General Public License Version 2)
 *
 * By continuing to use, modify, or distribute this file you indicate that you
 * have read the license and understand and accept it fully.
 *
 * The LCUI project is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GPL v2 for more details.
 *
 * You should have received a copy of the GPLv2 along with this file. It is
 * usually in the LICENSE.TXT file, If not, see <http://www.gnu.org/licenses/>.
 * ****************************************************************************/

/* ****************************************************************************
 * linux_x11events.c -- linux 平台的事件驱动支持，基于 xwindow。
 *
 * 版权所有 (C) 2016-2018 归属于 刘超 <lc-soft@live.cn>
 *
 * 这个文件是LCUI项目的一部分，并且只可以根据GPLv2许可协议来使用、更改和发布。
 *
 * (GPLv2 是 GNU通用公共许可证第二版 的英文缩写)
 *
 * 继续使用、修改或发布本文件，表明您已经阅读并完全理解和接受这个许可协议。
 *
 * LCUI 项目是基于使用目的而加以散布的，但不负任何担保责任，甚至没有适销性或特
 * 定用途的隐含担保，详情请参照GPLv2许可协议。
 *
 * 您应已收到附随于本文件的GPLv2许可协议的副本，它通常在LICENSE.TXT文件中，如果
 * 没有，请查看：<http://www.gnu.org/licenses/>.
 * ****************************************************************************/

#ifndef LCUI_LINUX_X11_EVENTS_H
#define LCUI_LINUX_X11_EVENTS_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>

typedef struct LCUI_X11AppDriverRec_ {
	int screen;
	Display *display;
	Window win_root;
	Window win_main;
	Atom wm_delete;
	Colormap cmap;
	LCUI_EventTrigger trigger;
} LCUI_X11AppDriverRec, *LCUI_X11AppDriver;

void LCUI_SetLinuxX11MainWindow( Window win );

void LCUI_PreInitLinuxX11App( void *data );

LCUI_AppDriver LCUI_CreateLinuxX11AppDriver( void );

void LCUI_DestroyLinuxX11AppDriver( LCUI_AppDriver driver );

#endif
